﻿@{ ViewBag.Title = "OrderAdmin";

                Layout = "~/Views/Shared/_Layout.cshtml"; }

<div class="row">
    <div class="col-sm-12">
        <div class="card">
            <div class="card-header d-flex justify-content-between">
                <ul class="nav">
                    <li class="nav-item" id="header-line">
                        <a class="nav-link" id="tab-header" data-toggle="pill" role="tab" aria-controls="custom-tabs-four-home" aria-selected="false">
                            <h6 class="box-title">
                                <i class="fas fa-tasks"></i> Lines Detail
                            </h6>
                        </a>
                    </li>
                </ul>
            </div>
            <div class="card-body">
                <table id="table_Order_Admin" class="table table-bordered table-striped">
                    <thead>
                        <tr>
                            <th>OrderNum</th>
                            <th>Line</th>
                            <th>Part</th>
                            <th>Part Description</th>
                            <th>Order Qty</th>
                            <th>UOM</th>
                            <th>Need By Date</th>
                            <th>Sync</th>
                        </tr>
                    </thead>
                </table>
            </div>
        </div>
    </div>
</div>


@section BodyLibrary{
    @*@DataTables@*@
    <script src="@Url.Content("~/adminlte/plugins/datatables/jquery.dataTables.min.js")"></script>
    <script src="@Url.Content("~/adminlte/plugins/datatables-bs4/js/dataTables.bootstrap4.min.js")"></script>
    <script src="@Url.Content("~/adminlte/plugins/datatables-responsive/js/dataTables.responsive.min.js")"></script>
    <script src="@Url.Content("~/adminlte/plugins/datatables-responsive/js/responsive.bootstrap4.min.js")"></script>
    @*@SweetAlert2@*@
    <script src="@Url.Content("~/adminlte/plugins/sweetalert2/sweetalert2.min.js")"></script>
    @*@Toastr@*@
    <script src="@Url.Content("~/adminlte/plugins/toastr/toastr.min.js")"></script>
    @*@DataRender@*@
    <script src="@Url.Content("~/adminlte/plugins/dataRender/dateTime.js")"></script>
    <script src="@Url.Content("~/adminlte/plugins/jsgrid/demos/db.js")"></script>
    <script src="@Url.Content("~/adminlte/plugins/jsgrid/jsgrid.min.js")"></script>
    @*@Select2@*@
    <script src="@Url.Content("~/adminlte/plugins/select2/js/select2.full.min.js")"></script>
    @*@Bootstrap Switch@*@
    <script src="@Url.Content("~/adminlte/plugins/bootstrap-switch/js/bootstrap-switch.min.js")"></script>
    @*@bootstrap color picker@*@
    <script src="@Url.Content("~/adminlte/plugins/bootstrap-colorpicker/js/bootstrap-colorpicker.min.js")"></script>
    @*@Select2@*@
    <script src="~/adminlte/plugins/select2/js/select2.full.min.js"></script>
    @*@jquery-validation@*@
    <script src="~/adminlte/plugins/jquery-validation/jquery.validate.min.js"></script>
    <script src="~/adminlte/plugins/jquery-validation/additional-methods.min.js"></script>

}

@section scripts{
    <!--function for tab_header-->
    <script type="text/javascript">
        var tableOrder;
        var NUMBER_ORDER;
        var RETURNURL = "https://localhost:44334/Order/Index";
        var CustID = '@ViewBag.CustID';
        var CustName = '@ViewBag.CustName';
        var OrderNumHed;
        var OrderNumDetail = 0;
        var table;
        var table_Order;
        var counter = 0;

        $("#btn-reload").click(function () {
            alert("Data successfully reloaded!");
            table.ajax.reload();
            console.log("selesai");
        });

        $(document).ready(function () {
            $("#table_Order_Admin").DataTable({
                "autoWidth": false,
                "responsive": true,
                "ajax": {
                    "url": '@Url.Action("GetAllOrder", "OrderAdmin")',
                    "type": "POST",
                    "datatype" : "JSON"
               },
               "columnDefs": [
                   {
                       "targets": 6,
                       "render": function (data) {
                           return moment(data).format('DD-MMM-YYYY');
                       },
                   },
               ],
               "paging": false,
               "searching": false,
               "filter": false, //disable filter
               "lengthChange": false, //disable 'show 10 entries'
               "bInfo": false, //disable 'showing 1 to N entries'
               "bPaginate": false, //disable page 1 2 3... Next button
               "columns": [
                   { "data": "OrderNum", "name": "OrderNum", "autoWidth": true },
                   { "data": "OrderLine", "name": "OrderLine", "autoWidth": true },
                   { "data": "PartNum", "name": "PartNum", "autoWidth": true },
                   { "data": "Description", "name": "Description", "autoWidth": true },
                   { "data": "OrderQty", "name": "OrderQty", "autoWidth": true },
                   { "data": "IUM", "name": "IUM", "autoWidth": true },
                   { "data": "NeedByDate", "name": "NeedByDate", "autoWidth": true },
                   //{
                   //    "data": "Synced",
                   //    "sClass": "text-center",
                   //    "render": function (data) {
                   //        if (data == false) return '<span class="btn btn-block btn-danger btn-sm">Sync</span> ';
                   //        if (data == true) return '<span class="btn btn-block btn-success btn-sm">Synced</span>';
                   //    }
                   //},
                   {
                       "searchable": false, "orderable": false, "sClass": "text-center", "width": "16%", "render": function (data, type, row) {
                           let btnActivated = "btn-info";
                           let btnText = "Sync";
                           if (row.Synced == true) {
                               btnActivated = "btn-danger";
                               btnText = "Synced";
                            }
                           return '<button type="button" data="' + row.OrderNum + '" data-status="' + row.Synced + '" class="btn btn-block btn-sm ' + btnActivated + '" onclick="SyncEpicor(\'' + row.OrderNum + '\', \'' + row.OrderNum + '\'); " id="btn - isActive">' + btnText + '</button>';
                           //return '<button type="button" data-status="' + row.Synced + '" class="btn btn-block btn-sm ' + btnActivated + '" id="btn-isActive">' + btnText + '</button>';
                       }
                   },
               ],
            });
        });

        function SyncEpicor(zUserName, zPassword) {

            zUserName = "manager";
            zPassword = "manager";
                        Swal.fire({
                title: 'Synchronize with Epicor',
                icon: "warning",
                text: 'Are you sure to synchronize all order with Epicor?',
                showCancelButton: true,
                confirmButtonColor: '#3085d6',
                cancelButtonColor: '#d33',
                cancelButtonText: 'Cancel',
                confirmButtonText: 'Yes',
                showLoaderOnConfirm: true,
                preConfirm: (login) => {
                    return $.ajax({
                        url: '@Url.Action("SyncEpicor", "OrderAdmin")',
                        type: "post",
                        dataType: "json",
                        data: JSON.stringify({ "Username": zUserName, "Password": zPassword }),
                        contentType: 'application/JSON; charset=utf-8'
                    }).then(response => {
                        if (!response.ok) {
                            messageFailed(response.statusText)
                        }
                        return response;
                    }).then(result => {
                        if (result.metaData.code === 200) {
                            messageSuccess(result.metaData.message, null)
                            setTimeout(function () {
                                table.ajax.reload();
                            }, 3000);


                        } else {
                            messageFailed(result.metaData.message)
                        }
                    }).catch(error => {
                        Swal.showValidationMessage(
                            `Request failed: ${error}`
                        )
                    })

                },
                allowOutsideClick: () => !Swal.isLoading()

            });

        }
    </script>
}